#pragma once
/********************************************************
	* @file    : error_api_define.h
	* @brief   : 쳣㷨ӿ2 õĶ
	* @details :
	* @author  : qqm
	* @date    : 2022.3.10
*********************************************************/
#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <unordered_map>

#include "public_define.h"

#if defined(_MSC_VER) || defined(_WIN32) || defined(_WIN64)
#define dll_export __declspec(dllexport)
#define dll_import __declspec(dllimport)
#else //  __linux__
#define dll_export __attribute__ ((visibility("default")))
#include <memory>
#endif
#define MAX_SOCRE_DEFINE 1000

/////////////////////////////쳣ӿ2صĽṹ////////////////////////////////
namespace eapi {
/// /ά
	struct ErCodeQ {
		preinfo::BOX_TYPE type;				///  뻹Ƕά
		std::string result;					/// ʶ
		preinfo::PaperRect<double> box;		/// 
		ErCodeQ() :type(preinfo::BOX_TYPE::BOX_EXAM_BARCODE), result("") {};
	};
	/// ͿжͨýŽṹ
	struct ErSinTt :preinfo::PaperRect<double> {
		bool filled;			/// ͿǷͿ
		int  fildedNumber;		/// Чжɫ 
		ErSinTt() :filled(false),fildedNumber(0) {};
	};
	/// ͿУѡ⣬ߵͿУ
	struct ErTtRes {
		std::vector<ErSinTt> smallBoxes;
		int id;					///   ֮
		int uuid;				/// uuid
		ErTtRes() :id(0) { smallBoxes.clear(); };
	};
	/// ѧͿ
	struct ErFillNumber {
		bool effective;						/// ǷЧ
		preinfo::PaperRect<double> box;		/// 
		std::string fillNumber;				/// Ϳʶ
		std::vector<ErTtRes> smallItems;	/// ÿһлеͿϢ	
		ErFillNumber() :effective(false), fillNumber("") { smallItems.clear(); };
	};
	/// ѡ Կɾ
	struct ErChoise {
		std::vector<ErTtRes> sinChoise;		/// ѡ
		ErChoise() { sinChoise.clear(); };
	};
	/// Score
	struct ErScore {
		bool effective;						/// ǷЧ - Ч Ҫȡ
		preinfo::SCORE_TYPE type;			/// ֿ
		bool withHalf;						/// Ƿ.5
		int	limit;							/// ޷ֵ ģjson"limit"ֶ
		double maxSocre;                    /// Сֵ
		int cols;							/// 
		preinfo::PaperRect<double> box;		/// ֿ
		std::vector<ErSinTt> smallBoxes;	/// ֿ
		std::vector<double> vecSocreValue;	/// ֿڷֵ
		ErScore() :effective(true) { smallBoxes.clear(); vecSocreValue.clear(); };
		double GetSocre()                   /// ȡôֿ
		{
			double ret = 0.0;
			if (effective)
			{
				if ( smallBoxes.size() == 1)
				{
					//գûз
					if (maxSocre == -1)
					{
						//ûСʸѡֵԼۺϵʾ
						ret = smallBoxes[0].fildedNumber > 0 ? MAX_SOCRE_DEFINE : 0;
					}
					else
					{
						//СʣС
						ret = smallBoxes[0].fildedNumber > 0 ? maxSocre : 0;
					}
				}
				else if (type == preinfo::SCORE_TYPE::NORMAL)
				{
					int selectred = -1;
					int maxred = 0;
					if (withHalf)
					{
						ret += smallBoxes[smallBoxes.size() - 1].fildedNumber > 0 ? 0.5 : 0;
						for (int m = 0; m < smallBoxes.size() - 1; m++)
						{
							if (maxred < smallBoxes[m].fildedNumber)
							{
								maxred = smallBoxes[m].fildedNumber;
								selectred = m;
							}
						}
					}
					else
					{
						for (int m = 0; m < smallBoxes.size(); m++)
						{
							if (maxred < smallBoxes[m].fildedNumber)
							{
								maxred = smallBoxes[m].fildedNumber;
								selectred = m;
							}
						}
					}
					if (selectred > -1)
						ret += vecSocreValue[selectred];
				}
				else if (type == preinfo::SCORE_TYPE::COMBIN)
				{
					int selectred = -1;
					int maxred = 0;
					//ʮλ
					int tw = limit / 10;
					for (int m = 1; m <= tw; m++)
					{
						if (maxred < smallBoxes[m].fildedNumber)
						{
							maxred = smallBoxes[m].fildedNumber;
							selectred = m;
						}
					}
					if (selectred > -1)
						ret += 10 * vecSocreValue[selectred];

					selectred = -1;
					maxred = 0;

					if (withHalf)
					{
						if (smallBoxes[smallBoxes.size() - 1].fildedNumber > 0)
							ret += 0.5;
						for (int m = tw + 1; m < smallBoxes.size() - 1; m++)
						{
							if (maxred < smallBoxes[m].fildedNumber)
							{
								maxred = smallBoxes[m].fildedNumber;
								selectred = m;
							}
						}
					}
					else
					{
						for (int m = tw + 1; m < smallBoxes.size(); m++)
						{
							if (maxred < smallBoxes[m].fildedNumber)
							{
								maxred = smallBoxes[m].fildedNumber;
								selectred = m;
							}
						}
					}
					if (selectred > -1)
						ret += vecSocreValue[selectred];
				}
				else
				{
					int selectred = -1;
					int maxred = 0;
					for (int m = 0; m < smallBoxes.size(); m++)
					{
						if (maxred < smallBoxes[m].fildedNumber)
						{
							maxred = smallBoxes[m].fildedNumber;
							selectred = m;
						}
					}
					if (selectred > -1)
						ret += vecSocreValue[selectred];
				}
			}
			else
			{
				ret = -1.0;
			}
			return ret;
		};
	};
	/// ͨ
	struct ErBox {
		int id;								/// ģڵID
		int uuid;							/// UUID
		int multiple;						/// ǷǶ
		int orderNumber;					/// Ŀ 
		int marktype;						/// markType
		preinfo::PaperRect<double> box;		/// 
		preinfo::BOX_TYPE type;				/// 
		ErScore score;						/// ֿ
		/// ѡͿ ѡʱЧ
		ErTtRes	xzTt;						/// ѡͿ
		ErBox() :id(0), type(preinfo::BOX_TYPE::BOX_NONE) {};
	};

	/// 쳣ӿڽṹ  
	typedef struct SingleErrorPaperInfo
	{
		/**
			ÿһŴ⿨ģϢϢĿϢʶϢ
		*/
		int					pageId;				/// ҳҳ
		int					status;				/// ҳ״̬
		std::string			strPath;			/// ͼ·

		ErFillNumber		fillNumber;			/// Ϳ
		std::vector<ErCodeQ> codeResult;		/// /άʶ
		ErChoise			choice;				/// ѡ
		std::vector<ErBox>	boxes;				/// ͨ
		SingleErrorPaperInfo() :pageId(-1), status(PAPER_SUCC), strPath("") {};
	}speinfo;
}